"""Generate a post.

"""
import ConfigParser, re, os
import archive.main, manage_visible
import toolkit.sequences

import modules.epilogue
from modules.epilogue import *
import modules.prologue
from modules.prologue import *

def execModules(obj,modules):
    """Executes all modules' main function just added to the global namespace."""
    try:
        for module in modules:
            globals()[module].__dict__['main'](obj)
        else: return 1
        return 0
    except:
        pass



def cgiToDict(cgi_dict):
    """Converts a cgi.FieldStorage object into a dictionary class."""
    reg_dict={}
    for key in cgi_dict.keys(): reg_dict[key]=cgi_dict[key].value
    return reg_dict

class Post:
    """Handles the creation of a post's HTML."""
    def __init__(self, info_dict=None):
        """Fetches post template and finds out where the posting page is."""
        if info_dict: self.data_dict=info_dict
        else: self.data_dict={}
        template_FILE=open(os.path.join('templates','post.html'),'r')
        try:
            self.template=template_FILE.read()
        finally:
            template_FILE.close()
        post_conf=ConfigParser.ConfigParser()
        post_conf.read(r'posts.conf')
        self.page_location=post_conf.get('settings','page_location')

    def addDataDict(self,dict):
        self.data_dict=dict

    def prepPost(self):
        execModules(self,modules.prologue.__all__)

    def createPost(self):
        """Takes post template and does necessary substituting to generate HTML."""
        post=self.template
        data_dict=self.data_dict
        for key in self.data_dict.keys():
            post=re.sub(r'<!--pyBlog insert/ %s-->' % key,data_dict[key],post)
        self.post=post
        ID=archive.main.add_post(self)
        return ID
        
    def finishPost(self,ID):
        execModules(self,modules.epilogue.__all__)
        manage_visible.add_post(self.post,ID)

    def add_post(self):
        """Executes methods in proper order to create post."""
        self.prepPost()
        ID=self.createPost()
        self.finishPost(ID)
