#!/usr/local/bin/python
"""Displays list of posts matching search and allows user to delete or make
visible the selected post."""

try:
    import cgi
    import security, PageGen, PostGen
    import archive.main

    print PageGen.page_header
    
    if not security.InternetSecurity().checkCookiePasswd():
        print PageGen.login_redirect

    else:
        search_CGI=cgi.FieldStorage()
        search_dict=PostGen.cgiToDict(search_CGI)
        search_results=archive.main.search_posts(search_dict)
        ordered_search_results=[]
        for ID,post in search_results:
            key_order=post.data_dict.keys()
            ordered_post=[]
            for key in key_order:
                ordered_post.append(post.data_dict[key])
            ordered_search_results.append([ID,ordered_post])
        page_info={'chunks':ordered_search_results,
                   'controls':[{'tag_type':'input','type':'submit','name':'service','value':'Delete'},
                               {'tag_type':'input','type':'submit','name':'service','value':'Make Visible'},
                                {'tag_type':'input','type':'reset','value':'clear'}]
                   }
        
        output_XHTML=PageGen.OutputPage('redirect.py')
        print output_XHTML.createPage(page_info)

except: 
    import sys, traceback
    print '<pre>'
    traceback.print_exc()
    print '</pre>'
