import types



NORMAL='normal'
UP='up'
DOWN='down'

class NameError(Exception):
    pass

def round(number, ndigits=0, direction='normal'):
    """Rounding function that can round up, down, or normally.

    CLASSES:
        NameError -- Exception class for round()

    FUNCTIONS:
        round(number, ndigits=0, direction=NORMAL) -> float -- Takes in a number
                    (with optional number of digits to round to and direction of the
                    round), and returns that number rounded accordingly.

    VARIABLES:
        NORMAL -- Used for round() to specify normal rounding.
        UP -- Used for round() to specify rounding up.
        DOWN -- Used for round() to specify rounding down.

"""
    direction=direction.lower()
    if direction!='normal' and direction!='up' and direction!='down':
        raise NameError
    number=float(number)
    rounded=round(number, ndigits)
    if direction=='up':
        if rounded < number:
            rounded=rounded+1.0/(pow(10, ndigits))
    elif direction=='down':
        if rounded > number:
            rounded=rounded-1.0/(pow(10, ndigits))
    return rounded






def decimalToN(num,n):
    """Change a decimal to a base-n number.
    Up to base-35 is supported naturally."""
    num_rep={10:'a',
         11:'b',
         12:'c',
         13:'d',
         14:'e',
         15:'f',
         16:'g',
         17:'h',
         18:'i',
         19:'j',
         20:'k',
         21:'l',
         22:'m',
         23:'n',
         24:'o',
         25:'p',
         26:'q',
         27:'r',
         28:'s',
         29:'t',
         30:'u',
         31:'v',
         32:'w',
         33:'x',
         34:'y',
         35:'z'}
    new_num_string=''
    current=num
    while current!=0:
        remainder=current%n
        if 36>remainder>9:
            remainder_string=num_rep[remainder]
        elif remainder>=36:
            remainder_string='('+str(remainder)+')'
        else:
            remainder_string=str(remainder)
        new_num_string=remainder_string+new_num_string
        current=current/n
    return new_num_string
    


def nToDecimal(num,n):
    """Change a base-n number to a decimal"""
    if not isinstance(num,types.StringType):
        num_string=str(num)
    else:
        num_string=num
    return int(num_string,n)
